<template src="./template.html"></template>

<script lang="ts">
import { Component, Vue } from "nuxt-property-decorator";
//@ts-ignore
import language from "~/locales/language-product.json";
import { api } from "~/common/constaint";
import { objectToParam } from "~/common/utils";
import { onGetListCart } from "~/utils/localStorage";
@Component({
  components: {},
})
export default class HeaderComponent extends Vue {
  search = "";
  drawerProduct = false;
  drawer = false;
  drawerMenuPolicy = false;

  loadingTable = false;
  loading = false;

  listPolicy = [
    { name: "Refund policy", link: "/refund-policy" },
    { name: "Privacy policy", link: "/privacy-policy" },
    { name: "Shipping policy", link: "/shipping-policy" },
    { name: "Terms of service", link: "/terms-of-service" },
    { name: "Return Policy", link: "/return-policy" },
  ];

  get logo() {
    const siteInfo = this.$store.state?.setting?.siteInfo;
    if (siteInfo?.logo?.imageUrl) {
      return `${api}/${siteInfo.logo.imageUrl}`;
    } else if (siteInfo?.logo) {
      return `${api}/${siteInfo.logo}`;
    }
    return "/logous.png";
  }

  slug = "";

  mounted() {
    this.slug = this.$route?.params?.slug || "";
  }

  get utm() {
    const query = this.$store.state.sitePage.utm || {};
    return objectToParam(query);
  }

  get isOnHomePage() {
    return this.$store?.state?.setting?.siteInfo?.isOnHomePage || false;
  }

  get domain() {
    return (
      this.$store?.state?.setting?.siteInfo?.domain
        .split(".")
        .slice(1)
        .join(".") || ""
    );
  }

  get colorVariant() {
    return this.$store.state.setting?.siteInfo?.colorVariant || "#fb5607";
  }

  get announcement() {
    return this.$store.state?.setting?.siteInfo.announcement || "";
  }

  get isHomePage() {
    return this.$store.state.product.isHomePage || false;
  }

  get setting() {
    return this.$store.state?.setting?.settingHomePage || {};
  }

  get isHeaderHomePage() {
    return this.$store.state?.setting?.isHeaderHomePage || false;
  }

  goHome() {
    if (this.drawer) this.drawer = false;
    if (this.slug) {
      this.$router.push(`/${this.slug}?${this.utm}`);
    } else {
      this.$router.push(`/?${this.utm}`);
    }
  }
  async onDecrease(variantProduct: any, i: number) {
    this.loading = true;
    const cart = onGetListCart();
    let variant = this.$utils.cloneDeep(variantProduct);
    if (variantProduct.quantity > 1) {
      variant.quantity -= 1;
      cart[i] = variant;
    }
    this.$store.commit("cart/setListCart", cart);
    localStorage.setItem("cart", JSON.stringify(cart));
    this.loading = false;
  }

  get $language() {
    if (this.$store.state.product.language.welcomeTo) {
      return this.$store.state.product.language;
    }
    return language.EN;
  }
}
</script>

<style src="./style.css"></style>
<style lang="scss" scoped>
.header {
  min-height: 213px;
  max-height: 213px;
  padding: 0px;
  @media (max-width: 960px) {
    max-height: 155px;
    min-height: 155px;
  }
}
.header-no-announcement {
  min-height: 133px;
  max-height: 133px;
  padding: 0px;
  @media (max-width: 960px) {
    max-height: 75px;
    min-height: 75px;
  }
}
.frame-logo {
  height: 136px;
  @media (max-width: 960px) {
    height: 66px;
  }
}
.row-cover {
  padding: 0 40px;

  @media (max-width: 960px) {
    padding: 0 15px;
  }
}

.side-menu {
  background: #1b1b1b;
  position: fixed;
  top: 0;
  left: 0;

  .main-side-menu {
    padding: 40px;
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
  }
}

.image-logo {
  width: 234px;
  height: 136px;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  padding: 8px 12px;
  cursor: pointer;

  @media (max-width: 960px) {
    height: 66px;
  }

  img {
    width: 100%;
    height: 100%;
    object-fit: scale-down;
    object-position: center;
  }
}
</style>
